// CDGeneral.cpp : implementation file
//

#include "stdafx.h"
#include "CDGeneral.h"
#include "..\UpDownClient.h"
#include "..\server.h"
#include "..\emule.h"
#include "..\IP2Country.h"


// CCDGeneral dialog

IMPLEMENT_DYNCREATE(CCDGeneral, CPropertyPage)

CCDGeneral::CCDGeneral() : CPropertyPage(CCDGeneral::IDD)
{
	//{{AFX_DATA_INIT(CCDGeneral)
	//}}AFX_DATA_INIT

	m_hClientIcon = NULL;
	m_eCurrClientSoft = SO_LAST;
}

CCDGeneral::~CCDGeneral()
{
	if(m_hClientIcon != NULL)
	{
		::DestroyIcon(m_hClientIcon);
	}
}

void CCDGeneral::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCDGeneral)
	DDX_Control(pDX, IDC_USERNAME_VAL, m_ctrlUserName);
	DDX_Control(pDX, IDC_USERHASH_VAL, m_ctrlUserHash);
	DDX_Control(pDX, IDC_SERVERNAME_VAL, m_ctrlServerName);
	DDX_Control(pDX, IDC_SERVERIP_VAL, m_ctrlServerIP);
	DDX_Control(pDX, IDC_IPADDRESS_VAL, m_ctrlClientIP);
	DDX_Control(pDX, IDC_ID_VAL, m_ctrlClientID);
	DDX_Control(pDX, IDC_CLIENTSOFTWARE_VAL, m_ctrlClientSoftware);
	DDX_Control(pDX, IDC_CLIENTICON, m_ctrlClientIcon);
	DDX_Control(pDX, IDC_IDENTIFICATION_VAL, m_ctrlIdentification);
	DDX_Control(pDX, IDC_BANNED_VAL, m_ctrlBanned);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CCDGeneral, CPropertyPage)
	//{{AFX_MSG_MAP(CCDGeneral)
		// NOTE: the ClassWizard will add message map macros here
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// CCDGeneral message handlers

BOOL CCDGeneral::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	Localize();
	Update();

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CCDGeneral::Update()
{
	static const uint16 s_auClientIconResID[] =
	{
		IDI_COMPROT32,			//SO_PLUS
		IDI_COMPROT32,			//SO_EMULE
		IDI_AMULE32,			//SO_AMULE
		IDI_EDONKEYHYBRID32,	//SO_EDONKEYHYBRID
		IDI_NORMAL32,			//SO_EDONKEY
		IDI_MLDONKEY32,			//SO_MLDONKEY
		IDI_SECUREHASH32,		//SO_OLDEMULE + non-SUI
		IDI_SHAREAZA32,			//SO_SHAREAZA
		IDI_XMULE32,			//SO_XMULE
		IDI_LPHANT32,			//SO_LPHANT
		IDI_UNKNOWN32			//SO_UNKNOWN
	};

	EMULE_TRY

	if(m_pClient == NULL)
		return;

	if(!::IsWindow(GetSafeHwnd()))
		return;

//	Reload icon only when client version is changed (e.g. Unknown->another)
	if (m_eCurrClientSoft != m_pClient->GetClientSoft())
	{
		m_eCurrClientSoft = m_pClient->GetClientSoft();
		if(m_hClientIcon != NULL)
		{
			::DestroyIcon(m_hClientIcon);
		}

		HINSTANCE	hInst = AfxGetInstanceHandle();
		uint32		dwIdx = m_eCurrClientSoft;

		if ((dwIdx == SO_EMULE) || (dwIdx == SO_PLUS))
		{
			if (m_pClient->m_pCredits->GetCurrentIdentState(m_pClient->GetIP()) != IS_IDENTIFIED)
				dwIdx = SO_OLDEMULE;
		}
		else if (dwIdx > SO_UNKNOWN)
			dwIdx = SO_UNKNOWN;
		m_hClientIcon = reinterpret_cast<HICON>(::LoadImage(hInst, MAKEINTRESOURCE(s_auClientIconResID[dwIdx]), IMAGE_ICON, 0, 0, 0));
		m_ctrlClientIcon.SetIcon(m_hClientIcon);
	}

	CString strBuffer;

	if (!m_pClient->IsUserNameEmpty())
		m_ctrlUserName.SetWindowText(m_pClient->GetUserName());
	else
		m_ctrlUserName.SetWindowText(_T("?"));
	
	if (m_pClient->HasValidHash())
	{
		TCHAR acHashStr[MAX_HASHSTR_SIZE];

		m_ctrlUserHash.SetWindowText(md4str(m_pClient->GetUserHash(), acHashStr));
	}
	else
		m_ctrlUserHash.SetWindowText(_T("?"));

	m_ctrlClientSoftware.SetWindowText(m_pClient->GetFullSoftVersionString());

	m_ctrlBanned.SetWindowText(m_pClient->GetBanString());

	strBuffer.Format(_T("%u (%s)"), m_pClient->GetUserID(),
						::GetResString((m_pClient->HasLowID()) ? IDS_PRIOLOW : IDS_PRIOHIGH));
	m_ctrlClientID.SetWindowText(strBuffer);

	strBuffer.Format(_T("%s:%u"), m_pClient->GetFullIP(), m_pClient->GetUserPort());
	if (g_App.m_pIP2Country->IsIP2Country())
		strBuffer.AppendFormat(_T(" (%s)"), m_pClient->GetCountryName());
	m_ctrlClientIP.SetWindowText(strBuffer);
	
	if (m_pClient->GetServerIP())
	{
		CString	strPort;
		in_addr	server;

		server.S_un.S_addr = m_pClient->GetServerIP();
		strBuffer.Format(_T("%s"), inet_ntoa(server));
		strPort.Format(_T(":%u"), m_pClient->GetServerPort());

		CServer	*pServer = g_App.m_pServerList->GetServerByAddress(strBuffer, m_pClient->GetServerPort()); 

		if (pServer != NULL)
		{
			if (g_App.m_pIP2Country->IsIP2Country())
				strPort.AppendFormat(_T(" (%s)"), pServer->GetCountryName());
			m_ctrlServerName.SetWindowText(pServer->GetListName());
		}
		else
			m_ctrlServerName.SetWindowText(_T("?"));
		m_ctrlServerIP.SetWindowText(strBuffer + strPort);
	}
	else
	{
		m_ctrlServerIP.SetWindowText(_T("?"));
		m_ctrlServerName.SetWindowText(_T("?"));
	}

	if (m_pClient->Credits())
	{
		UINT		dwResStrId = IDS_IDENTNOSUPPORT;

		if (g_App.m_pClientCreditList->CryptoAvailable())
		{
			switch (m_pClient->Credits()->GetCurrentIdentState(m_pClient->GetIP()))
			{
				case IS_NOTAVAILABLE:
				{
					break;
				}
				case IS_IDFAILED:
				case IS_IDNEEDED:
				case IS_IDBADGUY:
				{
					dwResStrId = IDS_IDENTFAILED;
					break;
				}
				case IS_IDENTIFIED:
				{
					dwResStrId = IDS_IDENTOK;
					break;
				}
			}
		}
		m_ctrlIdentification.SetWindowText(::GetResString(dwResStrId));
	}
	else
	{
		m_ctrlIdentification.SetWindowText(_T("?"));
	}

	EMULE_CATCH
}

void CCDGeneral::Localize(void)
{
	static const uint16 s_auResTbl[][2] =
	{
		{ IDC_USERHASH_LBL, IDS_CD_UHASH },
		{ IDC_IDENTIFICATION_LBL, IDS_CD_IDENT },
		{ IDC_CLIENTSOFTWARE_LBL, IDS_CD_CSOFT },
		{ IDC_CDG_IPADDRESS_LBL, IDS_CD_UIP },
		{ IDC_SERVERNAME_LBL, IDS_CD_SNAME },
	};
	static const uint16 s_auResTbl2[][2] =
	{
		{ IDC_ID_LBL, IDS_ID },
		{ IDC_SERVERIP_LBL, IDS_SERVERIP },
		{ IDC_BANNED_LBL, IDS_BANNED }
	};

	if (GetSafeHwnd())
	{
		CString strBuffer;

		for (uint32 i = 0; i < ELEMENT_COUNT(s_auResTbl); i++)
		{
			GetResString(&strBuffer, static_cast<UINT>(s_auResTbl[i][1]));
			SetDlgItemText(s_auResTbl[i][0], strBuffer);
		}
		for (uint32 i = 0; i < ELEMENT_COUNT(s_auResTbl2); i++)
		{
			GetResString(&strBuffer, static_cast<UINT>(s_auResTbl2[i][1]));
			strBuffer += _T(":");
			SetDlgItemText(s_auResTbl2[i][0], strBuffer);
		}
	}
}
