// FileDetails.h : header file
//
#pragma once

#include "..\resource.h"
#include "..\PartFile.h"
#include "..\MuleListCtrl.h"
#include "afxwin.h"

#include "FDGeneral.h"
#include "FDTransfer.h"
#include "FDSrcNames.h"
#include "FDParts.h"
#include "FDAviInfo.h"

/////////////////////////////////////////////////////////////////////////////
// CFileDetails

class CFileDetails : public CPropertySheet
{
	DECLARE_DYNAMIC(CFileDetails)

// Construction
public:
	CFileDetails(UINT nIDCaption, CPartFile* pFile, CWnd* pParentWnd = NULL, UINT iSelectPage = 0);
	CFileDetails(LPCTSTR pszCaption, CPartFile* pFile, CWnd* pParentWnd = NULL, UINT iSelectPage = 0);
	virtual ~CFileDetails();
	virtual BOOL OnInitDialog();

	void Init(CPartFile* pFile);

protected:
	CFDGeneral	m_wndGeneral;
	CFDTransfer	m_wndTransfer;
	CFDSrcNames	m_wndSourceNames;
	CFDAviInfo	m_wndAviInfo;
	CFDParts	m_wndParts;

	UINT		m_nTimer;

	CString		m_strGeneralTitle;
	CString		m_strTransferTitle;
	CString		m_strSourceNamesTitle;
	CString		m_strAviInfoTitle;
	CString		m_strPartsTitle;

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CFileDetails)
	public:
	protected:
	//}}AFX_VIRTUAL

protected:
	//{{AFX_MSG(CFileDetails)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnDestroy();
};
