// InputBox.cpp : implementation file
//

#include "stdafx.h"
#include "emule.h"
#include "InputBox.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


// InputBox dialog

IMPLEMENT_DYNAMIC(InputBox, CDialog)
InputBox::InputBox(CWnd* pParent /*=NULL*/)
	: CDialog(InputBox::IDD, pParent)
{
	m_cancel = true;
	m_bFilenameMode = false;
}

InputBox::~InputBox()
{
}

void InputBox::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(InputBox, CDialog)
	ON_BN_CLICKED(IDC_CLEANUP, OnCleanFilename)
END_MESSAGE_MAP()

void InputBox::OnOK()
{
	TCHAR acBuffer[510];

	m_cancel = false;
	if (GetDlgItem(IDC_TEXT)->GetWindowTextLength())
	{
		GetDlgItemText(IDC_TEXT, acBuffer, 510);
		m_return = acBuffer;
	}
	CDialog::OnOK();
}

void InputBox::SetLabels(CString title, CString defaultStr)
{
	m_title = title;
	m_default = defaultStr;
}

CString InputBox::GetInput()
{
	return m_return;
}

BOOL InputBox::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetDlgItemText(IDC_TEXT, m_default);
	SetWindowText(m_title);

	SetDlgItemText(IDCANCEL, GetResString(IDS_CANCEL));
	SetDlgItemText(IDC_CLEANUP, GetResString(IDS_CLEANUP));
	GetDlgItem(IDC_CLEANUP)->ShowWindow((m_bFilenameMode) ? SW_NORMAL : SW_HIDE);

	return TRUE;
}

void InputBox::OnCleanFilename()
{
	CString strFilename;
	GetDlgItemText(IDC_TEXT, strFilename);
	SetDlgItemText(IDC_TEXT, CleanupFilename(strFilename));
}
