// PPgMessaging.cpp : implementation file
//

#include "stdafx.h"
#include "emule.h"
#include "PPgMessaging.h"


// CPPgMessaging dialog

IMPLEMENT_DYNAMIC(CPPgMessaging, CPropertyPage)

CPPgMessaging::CPPgMessaging()
: CPropertyPage(CPPgMessaging::IDD) , acceptMessages(0)
, putMeInAwayState(FALSE)
, awayMessage(_T(""))
, filter(_T(""))
, commentsFilter(_T(""))
, acceptMessagesDesc(_T(""))
, otherDesc(_T(""))
, commentsDesc(_T(""))
, msgDesc(_T(""))
, commentsFilterDesc(_T(""))
, filterDesc(_T(""))
, awayMessageDesc(_T(""))
{	
}

CPPgMessaging::~CPPgMessaging() {
}

void CPPgMessaging::DoDataExchange(CDataExchange* pDX) {
	CPropertyPage::DoDataExchange(pDX);
	DDX_Radio(pDX, IDC_RB_IM_FROMALLUSERS, acceptMessages);
	DDX_Check(pDX, IDC_CB_IM_PUTMEAWAY, putMeInAwayState);
	DDX_Text(pDX, IDC_EDIT_IM_AWAYMESSAGE, awayMessage);
	DDX_Text(pDX, IDC_FILTER, filter);
	DDX_Text(pDX, IDC_FILTER2, commentsFilter);
	DDX_Control(pDX, IDC_EDIT_IM_AWAYMESSAGE, awayMessageEdit);
	DDX_Text(pDX, IDC_GB_IM_ACCEPT, acceptMessagesDesc);
	DDX_Text(pDX, IDC_GB_IM_OTHER, otherDesc);	
	DDX_Text(pDX, IDC_CMT, commentsDesc);
	DDX_Text(pDX, IDC_MSG, msgDesc);
	DDX_Text(pDX, IDC_FILTERLABEL2, commentsFilterDesc);
	DDX_Text(pDX, IDC_FILTERLABEL, filterDesc);
	DDX_Control(pDX, IDC_CB_IM_PUTMEAWAY, putMeAwayCheck);
	DDX_Text(pDX, IDC_LBL_IM_AWAYMESSAGE, awayMessageDesc);
	DDX_Control(pDX, IDC_RB_IM_FROMALLUSERS, fromAllUsersRadio);
	DDX_Control(pDX, IDC_RB_IM_ONLYFROMFRIENDS, onlyFromFriendsRadio);
	DDX_Control(pDX, IDC_RB_IM_ONLYFROMFRIENDS2, otherToLogRadio);
	DDX_Control(pDX, IDC_RB_IM_FROMNONE, fromNoneRadio);
}

void CPPgMessaging::Localize(void)
{
	if(::IsWindow(m_hWnd))
	{
		SetWindowText(GetResString(IDS_PW_IM_OPTIONS));
		GetResString(&acceptMessagesDesc, IDS_PW_IM_ACCEPT);
		GetResString(&otherDesc, IDS_PW_IM_OTHER);
		fromAllUsersRadio.SetWindowText(GetResString(IDS_PW_IM_FROMALLUSERS));
		onlyFromFriendsRadio.SetWindowText(GetResString(IDS_PW_IM_ONLYFROMFRIENDS));
		otherToLogRadio.SetWindowText(GetResString(IDS_PW_IM_ONLYFROMFRIENDS2));
		fromNoneRadio.SetWindowText(GetResString(IDS_PW_IM_FROMNONE));
		putMeAwayCheck.SetWindowText(GetResString(IDS_PW_IM_PUTMEAWAY));
		GetResString(&awayMessageDesc, IDS_PW_IM_AWAYMESSAGE);
		GetResString(&filterDesc, IDS_FILTERLABEL);
		GetResString(&msgDesc, IDS_MESSAGES);
		GetResString(&commentsFilterDesc, IDS_FILTERLABEL2);
		GetResString(&commentsDesc, IDS_COMMENTS);
		UpdateData(FALSE);
	}
}

void CPPgMessaging::LoadSettings(void) {
		
	acceptMessages = m_pPrefs->GetAcceptMessagesFrom() - 1;
	putMeInAwayState = m_pPrefs->GetAwayState();				
	awayMessage = m_pPrefs->GetAwayStateMessage();
	awayMessageEdit.EnableWindow(putMeInAwayState);
	filter = m_pPrefs->GetMessageFilter();		
	commentsFilter = m_pPrefs->GetCommentFilter();

	UpdateData(FALSE);
}

BEGIN_MESSAGE_MAP(CPPgMessaging, CPropertyPage)
	ON_BN_CLICKED(IDC_RB_IM_FROMALLUSERS, OnBnClickedRbImFromallusers)
	ON_BN_CLICKED(IDC_RB_IM_ONLYFROMFRIENDS, OnBnClickedRbImOnlyfromfriends)
	ON_BN_CLICKED(IDC_RB_IM_ONLYFROMFRIENDS2, OnBnClickedRbImOnlyfromfriends2)
	ON_BN_CLICKED(IDC_RB_IM_FROMNONE, OnBnClickedRbImFromnone)
	ON_BN_CLICKED(IDC_CB_IM_PUTMEAWAY, OnBnClickedCbImPutmeaway)
	ON_EN_CHANGE(IDC_EDIT_IM_AWAYMESSAGE, OnEnChangeEditImAwaymessage)
	ON_EN_CHANGE(IDC_FILTER, OnEnChangeFilter)
	ON_EN_CHANGE(IDC_FILTER2, OnEnChangeCommentsFilter)
END_MESSAGE_MAP()


// CPPgMessaging message handlers

BOOL CPPgMessaging::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	LoadSettings();
	Localize();

	return TRUE;
}

BOOL CPPgMessaging::OnApply() {
	
	if(m_bModified)
	{
		UpdateData(TRUE);
	
		m_pPrefs->SetAcceptMessagesFrom(acceptMessages + 1);
		m_pPrefs->SetAwayState(putMeInAwayState);	
		m_pPrefs->SetAwayStateMessage(awayMessage);	
		m_pPrefs->SetMessageFilter(filter);	
		m_pPrefs->SetCommentFilter(commentsFilter);

		SetModified(FALSE);
	}
	return CPropertyPage::OnApply();
}

void CPPgMessaging::OnBnClickedCbImPutmeaway() {

	UpdateData(TRUE);
	
	awayMessageEdit.EnableWindow(putMeInAwayState);
	if (putMeInAwayState)
		awayMessageEdit.SetFocus();
	SetModified();
}
