#pragma once

#include "preferences.h"
#include "afxwin.h"

// CPPgSMTP dialog

class CPPgSMTP : public CPropertyPage
{
	DECLARE_DYNAMIC(CPPgSMTP)

public:
	CPPgSMTP();
	virtual ~CPPgSMTP();

	void SetPrefs(CPreferences* in_prefs) {	m_pPrefs = in_prefs; }
	enum { IDD = IDD_PPG_SMTP };
	virtual BOOL OnInitDialog();
	virtual BOOL OnApply();
	
	void Localize(void);
	afx_msg void OnDataChange()		{ SetModified(); }
	afx_msg void OnEnChangeSMTPAuthenticated();

protected:
	CPreferences *m_pPrefs;
	
	bool m_bModified;
	void SetModified(BOOL bChanged = TRUE)
	{
		m_bModified = bChanged;
		CPropertyPage::SetModified(bChanged);
	}

	virtual void DoDataExchange(CDataExchange* pDX);
	DECLARE_MESSAGE_MAP()

private:
	void LoadSettings(void);
	
protected:
	CString SMTPServer;
	CString SMTPName;
	CString SMTPFrom;
	CString SMTPTo;
	CString SMTPUserName;
	CString SMTPPassword;
	BOOL SMTPAuthenticated;
	BOOL SMTPInfoEnabled;
	BOOL SMTPWarningEnabled;

private:
	CEdit SMTPServerEdit;
	CEdit SMTPNameEdit;
	CEdit SMTPFromEdit;
	CEdit SMTPToEdit;
	CEdit SMTPUserNameEdit;
	CEdit SMTPPasswordEdit;
	CButton SMTPAuthenticatedCheck;
	CButton SMTPInfoEnabledCheck;
	CButton SMTPWarningEnabledCheck;

	CString SMTPServerDesc;
	CString SMTPNameDesc;
	CString SMTPFromDesc;
	CString SMTPToDesc;
	CString SMTPUserNameDesc;
	CString SMTPPasswordDesc;
	CString SMTPAuthenticationFrame;
};
