//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

// Preview.cpp : implementation file
//

#include "stdafx.h"
#include "emule.h"
#include "Preview.h"
#include "otherfunctions.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

// CPreview

IMPLEMENT_DYNCREATE(CPreviewThread, CWinThread)

CPreviewThread::CPreviewThread()
{
}

CPreviewThread::~CPreviewThread()
{
}

BOOL CPreviewThread::Run()
{
	ASSERT (m_pPartFile);
	CFile* srcFile = 0;
	CFile destFile;
	try{
		srcFile = m_pPartFile->GetPartFileHandle().Duplicate();
		uint32 nSize = m_pPartFile->GetFileSize();
		CString strExtension = m_pPartFile->GetFileExtension();
		CString strPreviewName = CString(m_pPartFile->GetTempDir()) + _T("\\") + CString(m_pPartFile->GetFileName()).Mid(0,5) + _T("_preview.") + strExtension;
		bool bFullSized = true;
		if (strExtension == _T("mpg") || strExtension == _T("mpeg"))
			bFullSized = false;
		destFile.Open(strPreviewName, CFile::modeWrite | CFile::shareDenyWrite | CFile::modeCreate);
		srcFile->SeekToBegin();
		if (bFullSized)
			destFile.SetLength(nSize);
		destFile.SeekToBegin();
		BYTE abyBuffer[4096];

		uint32 nRead;
		while (destFile.GetPosition()+4096 < PARTSIZE*2)
		{
			nRead = srcFile->Read(abyBuffer,4096);
			destFile.Write(abyBuffer,nRead);
		}

		srcFile->Seek(-(PARTSIZE*2),CFile::end);
		uint32 nToGo =PARTSIZE*2;
		if (bFullSized)
			destFile.Seek(-(PARTSIZE*2),CFile::end);
		do
		{
			nRead = (nToGo - 4096 < 1)? nToGo:4096;
			nToGo -= nRead;
			nRead = srcFile->Read(abyBuffer,4096);
			destFile.Write(abyBuffer,nRead);
		}
		while (nToGo);

		destFile.Close();
		srcFile->Close();
		m_pPartFile->m_bPreviewing = false;
		SHELLEXECUTEINFO SE;			// Why so complicated and not just a 'simple' ShellExecute(...)??
		memzero(&SE, sizeof(SE));
		SE.fMask = SEE_MASK_NOCLOSEPROCESS ;
		SE.lpVerb = _T("open");
		CString player=g_App.m_pPrefs->GetVideoPlayer();
		if (!player.IsEmpty())
		{
			TCHAR	acShortPath[512];

			GetShortPathName(strPreviewName, acShortPath, 512);

			CString	strRunDir = player;
			int		i = strRunDir.ReverseFind(_T('\\'));

			strRunDir = (i >= 0) ? strRunDir.Left(i + 1) : _T("");
			SE.lpFile = player.GetString();
			SE.lpParameters = acShortPath;
			SE.lpDirectory = strRunDir.GetString();
		}
		else
			SE.lpFile = strPreviewName.GetString();
		SE.nShow = SW_SHOW;
		SE.cbSize = sizeof(SE);
		ShellExecuteEx(&SE);
		if (SE.hProcess)
		{
			WaitForSingleObject(SE.hProcess, INFINITE);
			DWORD dwExitCode;
			do
			{
				Sleep(300);
				GetExitCodeProcess(SE.hProcess,&dwExitCode);
			}
			while(dwExitCode == STILL_ACTIVE);
			CloseHandle(SE.hProcess);
		}
		CFile::Remove(strPreviewName);
	}	
	catch(CFileException* error)
	{
		m_pPartFile->m_bPreviewing = false;
		if (srcFile->m_hFile != INVALID_HANDLE_VALUE)
			srcFile->Close();
		if (destFile.m_hFile != INVALID_HANDLE_VALUE)
			destFile.Close();
		error->Delete();	//mf
	}
	if (srcFile)
		delete srcFile;
	AfxEndThread(0,true);
	return 0;
}

void CPreviewThread::SetValues(CPartFile* pPartFile,CString player)
{
	m_pPartFile = pPartFile;
	m_player = player;
}

BEGIN_MESSAGE_MAP(CPreviewThread, CWinThread)
END_MESSAGE_MAP()

// CPreview message handlers
